%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

Name: mMass
Summary: Open Source Mass Spectrometry Tool
Version: 5.5.0
Release: 16%{?dist}
License: GPLv3+
Group:   Applications/Engineering
URL: http://www.mmass.org/
Source0: http://www.mmass.org/download/files/v%{version}/mmass_v%{version}_source.zip

## Database links
Source1: http://www.mmass.org/download/files/compounds/compounds_lipidmaps.zip
Source2: http://www.mmass.org/download/files/compounds/compounds_norine.zip
Source3: http://www.mmass.org/download/files/compounds/compounds_fungal_peptides.zip

## Example links
Source4: http://www.mmass.org/download/files/examples/examples_general.zip
Source5: http://www.mmass.org/download/files/examples/examples_hdx.zip
Source6: http://www.mmass.org/download/files/examples/examples_cpeptides.zip

Source7: %{name}.desktop

## https://bugzilla.redhat.com/show_bug.cgi?id=1159957
Patch0: %{name}-remove-icc-profile.patch

BuildRequires: python2-devel
BuildRequires: desktop-file-utils 
BuildRequires: python-libs
BuildRequires: wxPython-devel
BuildRequires: numpy
BuildRequires: dos2unix
%if 0%{?fedora}
BuildRequires: libappstream-glib
%endif
Requires: wxPython
Requires: numpy
Requires: %{name}-examples

%description
While tools for the automated analysis of MS and LC-MS/ MS data are continuously improving,
it is still often the case that at the end of an experiment,
the mass spectrometrists will spend time carefully examining individual spectra.
Current software support is mostly provided only by the instrument vendors,
and the available software tools are often instrument-dependent. Such software can only be used
to analyze data from a specific instrument, and this causes serious problems
for laboratories that use more than one instrument.
This tight software-instrument relationship also causes problems for laboratories that
do not possess their own instruments, and have to obtain mass spectra from other,
collaborating, laboratories.
To provide a solution to these limitations I have started to develop mMass - open source
multi-platform tool for precise mass spectrometric data analysis and interpretation.

%package examples
Summary: %{name} examples
Group: Applications/Engineering
BuildArch: noarch
%description examples
%{name} examples data.

%package doc
Summary: %{name} documentation
Group: Applications/Engineering
BuildArch: noarch
%description doc
%{name} PDF User Guide.

%prep
%setup -q -n %{name}
mv readme.txt README.txt
rm mspy/calculations.so setup.py

sed -i 's/\r$//' license.txt

## Fix wrong-script-end-of-line-encoding error
dos2unix mspy/plot_canvas.py 

## Add Python shebang 
sed -i -e '1i#!/usr/bin/python' gui/*.py
sed -i -e '1i#!/usr/bin/python' mspy/*.py

## Unpacking zipped databases 
unzip %{SOURCE1}
mv LIPIDMAPS/readme.txt LIPIDMAPS/lipidmaps-readme.txt
rm -rf  __MACOSX

unzip %{SOURCE2} 
mv readme.txt norine-readme.txt

unzip %{SOURCE3}
mv readme.txt fungal_peptides-readme.txt

## Unpacking zipped examples and
## removing all useless/proprietary files
unzip %{SOURCE4}
rm -rf __MACOSX

unzip %{SOURCE5}
rm -rf __MACOSX

unzip %{SOURCE6}
rm -rf __MACOSX

%patch0 -p1

%build
## Need just build 'calculations' extension
pushd mspy
CFLAGS="$RPM_OPT_FLAGS" %{__python2} setup.py build
mv -f build/lib.*/calculations.so ./calculations.so
popd

%install
pushd mspy
%{__python2} setup.py install --skip-build --root $RPM_BUILD_ROOT
popd 

## Making installation directories
mkdir -p $RPM_BUILD_ROOT%{python2_sitearch}/%{name}
mkdir -p $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/configs
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/database
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/mspy
mkdir -p $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/gui
mkdir -p $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/gui/images/gtk
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}/gui/images/gtk
mkdir -p $RPM_BUILD_ROOT%{_bindir}

## Removing useless files
rm mspy/setup.py
rm mspy/*.pyd

## Allocating all files
install -p -m 755 mspy/*.py* $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/mspy
install -p -m 755 mspy/*.so $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/mspy
install -p -m 644 configs/*.xml $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/configs
install -p -m 755 gui/*.py* $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/gui
install -p -m 644 gui/images/gtk/icon_about.png $RPM_BUILD_ROOT%{python2_sitearch}/%{name}/gui/images/gtk
install -p -m 644 gui/images/gtk/icon_about.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/mmass.png
install -p -m 755 mmass.py* $RPM_BUILD_ROOT%{python2_sitearch}/%{name}
install -p -m 644 *.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/database
install -p -m 644 General*Examples/*.msd HDX*Examples/*.msd Cyclic*Peptide*Examples/*.msd $RPM_BUILD_ROOT%{_datadir}/%{name}/examples

desktop-file-install                           \
 --dir=$RPM_BUILD_ROOT%{_datadir}/applications \
%{SOURCE7}

## Make a symbolic link to mmass.py
ln -s %{python2_sitearch}/%{name}/mmass.py $RPM_BUILD_ROOT%{_bindir}/mmass

## Add Python shebang
sed -i -e '1i#!/usr/bin/python' $RPM_BUILD_ROOT/%{python2_sitearch}/%{name}/mmass.py
find %{buildroot}%{python2_sitearch} -name "*.py" | xargs sed -i '1s|/usr/bin/python|%{__python2}|'

%if 0%{?fedora}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/appdata
cat > $RPM_BUILD_ROOT%{_datadir}/appdata/%{name}.appdata.xml <<EOF
<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright 2014 Richard Hughes <richard@hughsie.com> -->
<component type="desktop">
  <id type="desktop">%{name}.desktop</id>
  <metadata_license>CC0-1.0</metadata_license>
  <summary>Open Source Mass Spectrometry Tool</summary>
  <categories>
   <category>Science</category>
   <category>Chemistry</category>
   <category>ComputerScience</category>
  </categories>
  <description>
    <p>
      Open Source Mass Spectrometry Tool
    </p>  
    <p>
       While tools for the automated analysis of MS and LC-MS/ MS data are continuously improving, it is still
       often the case that at the end of an experiment, the mass spectrometrists will spend time carefully
       examining individual spectra. Current software support is mostly provided only by the instrument
       vendors, and the available software tools are often instrument-dependent. Such software can only be used
       to analyze data from a specific instrument, and this causes serious problems for laboratories that use more
       than one instrument. This tight software-instrument relationship also causes problems for laboratories that
       do not possess their own instruments, and have to obtain mass spectra from other, collaborating,
       laboratories. To provide a solution to these limitations I have started to develop mMass - open source
       multi-platform tool for precise mass spectrometric data analysis and interpretation.
    </p>
  </description>
  <url type="homepage">http://www.mmass.org/</url>
  <screenshots>
    <screenshot type="default">https://sagitter.fedorapeople.org/mmass1.png</screenshot>
    <screenshot>https://sagitter.fedorapeople.org/mmass2.png</screenshot>
  </screenshots>
  <updatecontact>strohalm_at_biomed.cas.cz</updatecontact>
</component>
EOF
%endif

%if 0%{?fedora}
%check
appstream-util validate-relax --nonet $RPM_BUILD_ROOT%{_datadir}/appdata/*.appdata.xml
%endif

%files
%{!?_licensedir:%global license %%doc}
%license license.txt
%doc README.txt *-readme.txt
%{_bindir}/mmass
%{python2_sitearch}/%{name}/
%{python2_sitearch}/*.egg-info
%{_datadir}/%{name}/database/
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/mmass.png 
%if 0%{?fedora}
%{_datadir}/appdata/*.appdata.xml
%endif

%files examples
%{!?_licensedir:%global license %%doc}
%license license.txt
%doc README.txt *-readme.txt
%{_datadir}/%{name}/examples/

%files doc
%doc *Guide.pdf
%{!?_licensedir:%global license %%doc}
%license license.txt

%changelog
* Sat Feb 20 2016 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-16
- Python files moved in the python2_sitearch directory

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 5.5.0-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sun Jul 12 2015 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-14
- appdata file only on Fedora

* Sun Jul 12 2015 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-13
- Re-arranged the dependencies of packages
- Used %%license
- Description improved
- Made the appdata file

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.5.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Feb 11 2015 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-11
- Rebuilt after wxPython upgrade

* Tue Nov 04 2014 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-10
- Copied .png icon in %%{_datadir}/pixmaps

* Tue Nov 04 2014 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-9
- Set Icon key in .desktop file (bz#1159560)
- Made a symbolic link to mmass.py (bz#1160166)
- Remove icc profile from embedded images (bz#1159957)

* Sat Nov 01 2014 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-8
- Fixed Requires packages
- SPEC file cleanups
- Adapted to the Python guide lines for EPEL6

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.5.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Nov 19 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-5
- Update LIPID MAPS Database (November 16, 2013)
- User Guide packaged in the .doc subpackage
- Installed new .desktop file

* Tue Sep 17 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-4
- Fixed shebang and wrong-script-end-of-line-encoding  errors
- Added BR dos2unix
- Subpackage database built in main package

* Fri Sep 13 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-3
- examples and database directories are now owned by package
- Set compiler flags
- Main software files now are placed in %%{_libdir}/%%{name}

* Fri Sep 13 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-2
- Python shebang addendum moved to %%prep section
- Use macros in the 'mmass' file creation

* Tue Aug 27 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-1
- Initial build
- 'calculations.so' library destination changed to 'mspy' subdirectory
- Created a 'mmass' binary file 
- Added commands to remove all useless/proprietary/hidden files
